#include <gd.h>

#define RGB32_TO_RGB16(pixel)  ( (((pixel) & 0xF80000) >> 8) | \
                                 (((pixel) & 0x00FC00) >> 5) | \
                                 (((pixel) & 0x0000F8) >> 3) )

void do_update(char* tempfilename)
{
	FILE *fbout;
	int i,j;
	int c,d;
	int *img_size;
	char *outputPtr;
	gdImagePtr gdPtr;

	// Try to prescale the image and check if it failed in a simple one-liner!
	if(strcmp((gdPtr = (char*)prescale_image(tempfilename)), "FAILURE") == 0)
	{
		printf("Could not open input file %s!\n", tempfilename);
		return 63;
	}

	// open the framebuffer (should lock it and die if this fails
        fbout = fopen("/dev/fb1", "wb+");

	/* read color value from pixel (left->right, up-> down) then convert
         * from RGB32 to RGB16 using code from directfb */
	for (j = 0; j < gdImageSY(gdPtr); j++) {
		for (i = 0; i < gdImageSX(gdPtr); i++) {
			c = RGB32_TO_RGB16(gdImageGetPixel(gdPtr, i, j));
			fwrite(&c,2,1,fbout);
		}
	}
	fclose(fbout);
	gdFree(outputPtr);
	return 0;
}

